#include "stdafx.h"
#include "FTSLayoutOffset.h"
#include "ClientConfig.h"

namespace ftsLayOutOffset{

	//////////////////////   Bubble    ////////////////////////////
	struct BubbleCommonInfo : public commonInfo
	{
		int bubble_to_image_left;
		int bubble_to_image_right;
		int bubble_to_image_top;

		int bubble_to_item_top ;
		int filename_to_bubble_left;
		int filename_to_bubble_right;

		int bubble_width;
		int bubble_height;

		int filename_to_bubble_inner_buttom;
		

		virtual int GetFileIconWidth()  const 
		{
			return bubble_width;
		}
		virtual int GetFileIconHeight() const 
		{
			return bubble_height;
		}
		virtual int GetFileIconEdgeX(BOOL bRight) const
		{
			int nRet = bubble_to_image_left;
			if (bRight)
			{
				nRet = bubble_to_image_right;
			}
			return nRet;
		}
		virtual int GetFileIconEdgeY() const
		{
			return bubble_to_image_top;
		}

		virtual int GetFileNameInnerEdgeY() const
		{
			return filename_to_bubble_inner_buttom;
		}

		BubbleCommonInfo()
		{
			bubble_to_image_left   = 12;
			bubble_to_image_right  = 16;

			bubble_to_image_top    = 9;

			bubble_to_item_top     = 0;

			filename_to_bubble_inner_buttom = 11;
			filename_to_fileicon_top = 9;

			//filename_fontheight_offset = 8;
			filename_to_bubble_left = 10;
			filename_to_bubble_right = 10;

			icon_file_type_width = 36;
			icon_file_type_height = 44;
			progressbar_width = 114;
			progressbar_height = 7;
			progressbar_to_bubble_left = 18;
			progressbar_to_bubble_right = 29;
			progressbar_top = 4;
			divider_width = 1;
			divider_height = 12;
			divider_height_offset = 2;
			divider_to_progressOrStatus_left = 8 - 3;
			button_to_divider_left = 8;

			icon_cancel_width = 16;
			icon_cancel_height = 16;

			HDC hDC = GetDC(NULL);
			font_height = 8;
			::ReleaseDC(NULL, hDC);

			clr_text_normal = (ARGB)(0xFFFFFFFF);
			clr_text_link   = (ARGB)(0xFF0e44e0);
			clr_progress_text = (ARGB)(0xFF00000);  //will not use in bubble model
			clr_divider = (ARGB)(0xFFb8b8b8);

			bubble_width = icon_file_type_width + 27;
			bubble_height = 20 + icon_file_type_height;
		}
	};
	
	struct BubbleSendInfo : public sendInfo
	{
		BubbleSendInfo()
		{
			icon_to_item_top = 0;
			icon_to_item_left = 0;
			icon_to_item_bottom = 0;

			filename_color = (ARGB)(0xFFFFFFFF);

			filename_to_icon_top   = 11;
			filename_to_icon_right = 10;
			filename_to_icon_left = 11;
			filename_to_item_right = 15;

			//progress_to_cancel_left = 7;
			progress_to_cancel_right = 8;

			progress_to_filename_top = 7;
			cancel_to_progress_right = 10;
			cancel_to_filename_bottom = 6;
		}
	};

	struct BubbleRecvInfo : public recvInfo
	{
		BubbleRecvInfo()
		{
			icon_to_item_top = 0;
			icon_to_item_left = 20;
			icon_to_item_bottom = 0;

			filename_color = (ARGB)(0xFF000000);
			left_corner_unvisible_width = 5;
			filename_to_icon_top = 9;
			filename_to_icon_left = 11;
			filename_to_item_right = 15;

			progress_to_filename_top = 7;
			progress_to_cancel_right = 7;

			button_down_width = 63;
			button_down_height = 20;
			button_to_progress_right = 10;

		}
	};

	//////////////////////   Plain    ////////////////////////////
	struct PlainCommonInfo : public commonInfo
	{
		virtual int GetFileIconWidth() const 
		{
			return icon_file_type_width;
		}
		virtual int GetFileIconHeight() const 
		{
			return icon_file_type_height;
		}
		virtual int GetFileIconEdgeX(BOOL bRight) const
		{
			return 0;
		}
		virtual int GetFileIconEdgeY() const
		{
			return 0;
		}
		PlainCommonInfo()
		{
			icon_file_type_width = 34;
			icon_file_type_height = 42;
			progressbar_width = 35;
			progressbar_height = 13;
			progressbar_top = 0;
			divider_width = 1;
			divider_height = 12;
			divider_height_offset = 2;
			divider_to_progressOrStatus_left = 8 - 3;
			button_to_divider_left = 8;
			icon_cancel_height = 0;
			icon_cancel_width  = 0;

			HDC hDC = GetDC(NULL);
			font_height = (REAL)MulDiv(12, 72, GetDeviceCaps(hDC, LOGPIXELSY));
			::ReleaseDC(NULL, hDC);

			clr_text_normal = (ARGB)(0xFF888888);
			clr_text_link   = (ARGB)(0xFF0e44e0);
			clr_progress_text = (ARGB)(0xFF4796f4);
			clr_divider = (ARGB)(0xFFb8b8b8);
		}
	};

	struct PlainRecvInfo : public recvInfo
	{
		PlainRecvInfo() : recvInfo()
		{
			icon_to_item_top = 3;
			icon_to_item_left = 29;
			icon_to_item_bottom = 16;
			
			filename_color = (ARGB)(0xFF888888);

			filename_to_icon_left = 8;
			filename_to_icon_top = 1 + 3;
			filename_to_item_right = 26;
			
			progress_to_filename_top = 6;
			progress_to_cancel_right = 8;

			button_to_progress_right = 8;

			button_down_width = 0;
			button_down_height = 0;
		}
	};

	struct PlainSendInfo : public sendInfo
	{
		PlainSendInfo() : sendInfo()
		{
			filename_to_icon_right = 0;
			icon_to_item_top = 3;
			icon_to_item_left = 57;
			icon_to_item_bottom = 16;
			filename_color = (ARGB)(0xFF888888);
			filename_to_item_right = 26;

			filename_to_icon_left = 8;
			filename_to_icon_top = 1 + 3;

			progress_to_filename_top = 6;
			cancel_to_progress_right = 8;
		}
	};

	Layout::Layout()
	{
		m_pCommonInfo = NULL;
		m_pSendInfo = NULL;
		m_pRecvInfo = NULL;
	}

	Layout::~Layout()
	{
		if (m_pCommonInfo)
		{
			delete m_pCommonInfo;
			m_pCommonInfo = NULL;
		}
		if (m_pSendInfo)
		{
			delete m_pSendInfo;
			m_pSendInfo = NULL;
		}
		if (m_pRecvInfo)
		{
			delete m_pRecvInfo;
			m_pRecvInfo = NULL;
		}
	}

	struct BubbleLayout : public Layout
	{
		BubbleLayout() : Layout()
		{
			m_pCommonInfo = new BubbleCommonInfo();
			m_pSendInfo = new BubbleSendInfo();
			m_pRecvInfo = new BubbleRecvInfo();
		}
	};

	struct PlainLayout : public Layout
	{
	public:
		PlainLayout() : Layout()
		{
			m_pCommonInfo = new PlainCommonInfo();
			m_pSendInfo = new PlainSendInfo();
			m_pRecvInfo = new PlainRecvInfo();
		}
	};

	static BubbleLayout sBubbleLayout;
	static PlainLayout sPlainLayout;

	const Layout& GetCurrentLayout(int nDisplayType)
	{
		if (CHAT_BUBBLE == nDisplayType)
		{
			return sBubbleLayout;
		}
		else
		{
			return sPlainLayout;
		}
	}
}